import java.io.*;

public class DemoIO
{
    public static void testBridge() throws IOException {
        try (FileOutputStream fos = new FileOutputStream("out.bin")) {
            bridge(fos);
        }
        bridge(System.out);
    }
    
    public static void bridge(OutputStream os) throws IOException {
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(os, "windows-1250"));
        bw.write("ahoj");
        bw.newLine();
    }
    
    public static void backupTxt(Writer writer) throws IOException {
        Employee p1 = new Employee(2000, "Karel Omacka");
        Employee p2 = new Employee(2001, "Josef Novak");
        
        BufferedWriter bw = new BufferedWriter(writer);
        
        bw.write(""+p1.getId());
        bw.write(":");
        bw.write(p1.getName());
        bw.newLine();
        bw.write(""+p2.getId());
        bw.write(":");
        bw.write(p2.getName());
        bw.newLine();
        
        bw.flush();
    }
    
    public static void recoverTxt() throws IOException {
        try (BufferedReader br = new BufferedReader(new FileReader("out.txt"))) {
            String line = br.readLine();
            while (line != null) {
                String[] rec = line.split(":", 2);
                if (rec.length != 2) throw new IOException("sdasd");
                try {
                    int id = Integer.parseInt(rec[0]);
                    Employee em = new Employee(id, rec[1]);  
                    System.out.println(em);
                } catch(NumberFormatException ex) {
                    throw new IOException("sdasd", ex);
                }
                line = br.readLine();
            }
        }
    }
    
    public static void backupAndRecoverBin() throws IOException, ClassNotFoundException {
        Employee p1 = new Employee(2000, "Karel Omacka");
        Employee p2 = new Employee(2001, "Josef Novak");
        
        try (ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream("out.bin"))) {
            oos.writeInt(p1.getId());
            oos.writeObject(p1.getName());
            oos.writeInt(p2.getId());
            oos.writeObject(p2.getName());
        }
        
        try (ObjectInputStream ois = new ObjectInputStream(new FileInputStream("out.bin"))) {
            Object str = ois.readObject();
            if (!(str instanceof String)) {
                throw new IOException("Wrong file format");
            }
            p1 = new Employee(ois.readInt(), (String) str);
        }
        
        System.out.println(p1);
        System.out.println(p2);
    }
    
    public static void printStream(OutputStream os) {
        Employee p1 = new Employee(2000, "Karel Omacka");
        Employee p2 = new Employee(2001, "Josef Novak");
        
        PrintStream ps = new PrintStream(os);
        ps.println(p1.getId() + ":" + p1.getName());
        ps.println(p2.getId() + ":" + p2.getName());
        
        if (ps.checkError()) {
            //throw new ...
        }
    }
    
}







